unit Main_pas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Db, DBTables, ExtCtrls, ComCtrls, DBCtrls, Grids,
  DBGrids, Wwdbigrd, Wwdbgrid, Wwdatsrc, Wwquery, comlib, Menus, SetGrid,
  comobj;

type
  TForm1 = class(TForm)
    ButtonSQLExec: TButton;
    ButtonClearSQL: TButton;
    ButtonClearResult: TButton;
    ButtonSave: TButton;
    ButtonExit: TButton;
    MemoSQL: TMemo;
    MemoOutput: TMemo;
    Query1: TwwQuery;
    SaveDialog1: TSaveDialog;
    DataSource1: TwwDataSource;
    Label1: TLabel;
    Delimiter: TEdit;
    ChBColName: TCheckBox;
    ChBLeftBrace: TCheckBox;
    ChBRightBrace: TCheckBox;
    EdInsertInto: TEdit;
    EdValues: TEdit;
    ChBEachRow: TCheckBox;
    Label2: TLabel;
    LabelFieldCnt: TLabel;
    Label3: TLabel;
    LabelRecCnt: TLabel;
    LabelRecNo: TLabel;
    Label5: TLabel;
    CmbTables: TComboBox;
    MemoFields: TMemo;
    rbTXT: TRadioButton;
    rbXLS: TRadioButton;
    Database1: TDatabase;
    ComboBox1: TComboBox;
    ProgressBar1: TProgressBar;
    EditCopybrd: TEdit;
    RichEditClipbrd: TRichEdit;
    DBImage1: TDBImage;
    Timer1: TTimer;
    DBGrid1: TwwDBGrid;
    PopupMenu1: TPopupMenu;
    mnuSQLOut: TMenuItem;
    mnuDataOut: TMenuItem;
    mnuSetGrid: TMenuItem;
    mnuExcelOut: TMenuItem;
    chbShowMemo: TCheckBox;
    procedure ButtonSQLExecClick(Sender: TObject);
    procedure ButtonClearSQLClick(Sender: TObject);
    procedure ButtonClearResultClick(Sender: TObject);
    procedure ButtonSaveClick(Sender: TObject);
    procedure ButtonExitClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ChBEachRowClick(Sender: TObject);
    procedure CmbTablesEnter(Sender: TObject);
    procedure CmbTablesKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure MemoSQLExit(Sender: TObject);
    procedure MemoSQLEnter(Sender: TObject);
    procedure MemoFieldsEnter(Sender: TObject);
    procedure MemoFieldsExit(Sender: TObject);
    procedure MemoOutputEnter(Sender: TObject);
    procedure MemoOutputExit(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure MemoOutputDblClick(Sender: TObject);
    procedure MemoOutputMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure mnuSQLOutClick(Sender: TObject);
    procedure mnuSetGridClick(Sender: TObject);
    procedure mnuDataOutClick(Sender: TObject);
    procedure mnuExcelOutClick(Sender: TObject);
  private
    { Private declarations }
    function TFieldTypeToStr(intype: TfieldType): string;
    procedure checkAndPutEditText;
    procedure MemoOutputCopyToClipbrd;
    procedure MemoOutputPasteFromClipboard;
    procedure stringsCopyToClipbrd(in_strings: string);
    procedure stringsPasteFromClipbrd;
// 20051229 by wya
    function BooleanToInteger(inValue: Boolean): Byte;
  public
    { Public declarations }
    intoFileName: string;
    First_Prompt: Boolean;
    ori_database: string;

    LoginAdm: Variant; //IsT2Adminһܼ
    User_ID: string;
    User_NAME: string; // User name
    IP_Address: string; // User IP Address
    FDataBase: string; // Database Type
    SVR_NAME: string;
    PASSWORD: string;
  end;

var
  Form1: TForm1;

implementation
uses XLSFile;

{$R *.DFM}

// 20051229 by wya

function TForm1.BooleanToInteger(inValue: Boolean): Byte;
begin
  if inValue = true then
    Result := 1
  else
    Result := 0;
end;

function TForm1.TFieldTypeToStr(intype: TfieldType): string;
begin
  case intype of
    ftString: result := 'char';
    ftSmallint: result := 'smallint';
    ftInteger: result := 'integer';
    ftWord: result := 'word';
    ftBoolean: result := 'boolean';
    ftFloat: result := 'float';
    ftCurrency: result := 'currency';
    ftDate: result := 'date';
    ftTime: result := 'time';
    ftDateTime: result := 'datetime';
    ftMemo: result := 'memo';
    ftBlob: result := 'image';
    ftTypedBinary: result := 'TypedBinary';
    else
      result := 'Unknown'
  end;
end;

procedure TForm1.ButtonSQLExecClick(Sender: TObject);
var
  temp, Str_insertinto: string;
  i, j, Cnt_Field: Integer;
  field_type: array[0..100] of string;
// 20060309 add by wya down 2 line
  isfield_type_in_field: boolean;
  tmp_field_type: string;
begin
  if not (CompareStr('select', LowerCase((copy(MemoSQL.Text, 1, 6)))) = 0) then
    begin
      MessageDlg('OHselect}l', mtWarning, [mbOK], 0);
      MemoSQL.SetFocus;
    end
  else
    begin
      screen.Cursor := crHourGlass;
      checkAndPutEditText;

      DBImage1.DataField := '';
      DBImage1.AutoDisplay := false;
      DBGrid1.Enabled := true;

      if not chbShowMemo.Checked then
        if ChBEachRow.Checked then
          begin
            MemoOutput.Lines.Add('use totals2');
            MemoOutput.Lines.Add('go');
          end;
      with Query1 do
        begin
          close;
          sql.clear;
          SQL.Add('select cnt=count(*) ' + copy(MemoSQL.text, pos('from', lowercase(MemoSQL.text)), length(MemoSQL.text)));
          try
            Prepare;
            Open;
            LabelRecCnt.Caption := IntToStr(fieldbyname('cnt').asinteger);
          except
          end;

          sql.clear;
          SQL := MemoSQL.Lines;
          Prepare;
          Open;

          if not chbShowMemo.Checked then
            begin
              Cnt_Field := FieldCount;
              LabelFieldCnt.Caption := IntToStr(Cnt_Field);
              if recordcount > 0 then
                LabelRecCnt.Caption := IntToStr(recordcount);

              for j := 0 to Cnt_Field - 1 do
                begin
                  if (Fields[j].DataType = ftblob) or (Fields[j].DataType = ftTypedBinary) then
                    begin
                      try
                        DBImage1.DataField := Fields[j].fieldName;
                        DBImage1.AutoDisplay := true;
                        DBImage1.show;
                      except
                        DBImage1.AutoDisplay := false;
                      end;
                    end;
                  if (Fields[j].datatype = ftSmallint)
                    or (Fields[j].datatype = ftInteger)
                    or (Fields[j].datatype = ftWord)
                    or (Fields[j].datatype = ftFloat)
                    or (Fields[j].datatype = ftCurrency)
// 20051229 by wya
                  or (Fields[j].datatype = ftBoolean)
// 20060316 by wya
                  or (Fields[j].datatype = ftBlob) then
                    field_type[j] := ''
                  else
                    field_type[j] := '''';
                end;
              Str_insertinto := '';
              if ChBColName.Checked then
                begin
                  temp := '';
                  if ChBLeftBrace.Checked then temp := temp + '(';
                  for j := 0 to Cnt_Field - 1 do
                    begin
                      temp := temp + Fields[j].FieldName;
                      if j < (Cnt_Field - 1) then temp := temp + Delimiter.Text;
                    end;
                  if ChBRightBrace.Checked then temp := temp + ')';
                  if ChBEachRow.Checked then
                    begin
                      Str_insertinto := Str_insertinto + EdInsertInto.Text + ' ';
                      Str_insertinto := Str_insertinto + temp + ' ';
                      Str_insertinto := Str_insertinto + EdValues.Text + ' ';
                    end
                  else
                    MemoOutput.Lines.Add(temp);
                end;

              ProgressBar1.Position := 0;
              ProgressBar1.Min := 0;
              ProgressBar1.Max := RecordCount;
              for i := 0 to strtoint(LabelRecCnt.Caption) - 1 do
                begin
                  LabelRecNo.Caption := IntToStr(i + 1);
                  LabelRecNo.Update;
                  ProgressBar1.StepBy(1);

                  temp := '';
                  if ChBLeftBrace.Checked then temp := temp + '(';
                  for j := 0 to Cnt_Field - 1 do
                    begin
    // 20060309 by wya begin
                      isfield_type_in_field := false;
                      if (length(field_type[j]) > 0) and (Pos(field_type[j], Fields[j].AsString) > 0) then
                        begin
                          isfield_type_in_field := true;
                          tmp_field_type := '"';
                        end
                      else
                        tmp_field_type := field_type[j];
    // 20060309 by wya end
//20060804 by wya nullP_ add begin
                      if (Fields[j].IsNull) then
                        begin
                          temp := temp + 'null';
                        end
                      else
                        begin
//20061202 by wya add begin origin else
                          if true then
                            temp := temp + tmp_field_type + get_Field_Value(Fields[j]) + tmp_field_type
                          else
                            begin
//20061202 by wya add end
//20060804 by wya nullP_ add end
                              temp := temp + tmp_field_type;
                              if fields[j].datatype = ftdatetime then
                                temp := temp + formatdatetime('yyyy/mm/dd hh:mm:ss', Fields[j].Asdatetime)
                              else
                                if Fields[j].datatype = ftBoolean then
                                  temp := temp + inttostr(booleantointeger(Fields[j].asboolean))
                                else
                                  if Fields[j].datatype = ftBlob then // 20060316 by wya
                                    temp := temp + '0x' + StrToHexStr(Fields[j].asstring)
                                  else
                                    temp := temp + Fields[j].AsString;
                              temp := temp + tmp_field_type;
//20060804 by wya nullP_ add down 1 line
                            end;
//20061202 by wya add down 1 line
                        end;
                      if j < (Cnt_Field - 1) then temp := temp + Delimiter.Text;
                    end;
                  if ChBRightBrace.Checked then temp := temp + ')';
                  if ChBEachRow.Checked then
                    MemoOutput.Lines.Add(Str_insertinto + temp)
                  else
                    MemoOutput.Lines.Add(temp);
                  if ((i + 1) mod 3000 = 0) and (ChBEachRow.Checked) then
                    MemoOutput.Lines.Add('go');
                  Next;
                end;
            end;
        end;
      if not chbShowMemo.Checked then
        begin
          if ChBEachRow.Checked then
            begin
              MemoOutput.Lines.Add('go');
            end;
        end;
      screen.Cursor := crDefault;
    end;
end;

procedure TForm1.ButtonClearSQLClick(Sender: TObject);
begin
  Query1.SQL.Clear;
  MemoSQL.Lines.Clear;
end;

procedure TForm1.ButtonClearResultClick(Sender: TObject);
begin
  MemoOutput.Lines.Clear;
end;

procedure TForm1.ButtonSaveClick(Sender: TObject);
begin
  if rbTXT.Checked then
    begin
      if ChBEachRow.Checked then
        begin
          SaveDialog1.FilterIndex := 2;
          SaveDialog1.FileName := intoFileName + '.sql';
        end
      else
        begin
          SaveDialog1.FilterIndex := 1;
          SaveDialog1.FileName := intoFileName + '.txt';
        end
    end
  else
    begin
      checkAndPutEditText;
      SaveDialog1.filename := intoFileName;
      SaveDialog1.DefaultExt := '.xls';
      SaveDialog1.Filter := '*.xls|*.xls|*.*|*.*';
    end;
  if SaveDialog1.Execute then
    begin
      if rbTXT.checked then
        MemoOutput.Lines.SaveToFile(SaveDialog1.FileName)
      else
        begin
          LabelRecNo.Caption := '0';
          Query1.close;
          Query1.sql.text := MemoSQL.lines.text;
          Query1.open;
          DataSetToXLS(Query1, SaveDialog1.filename, true);
          Query1.close;
        end;
    end;
end;

procedure TForm1.ButtonExitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  ori_database := DataBase1.AliasName;
  First_Prompt := true;
  Form1.Caption := 'ʺAadߵGনr With Server:[' + Database1.AliasName + '] ';
  DataBase1.Session.GetTableNames(Database1.DatabaseName, '', false, false, CmbTables.items);
  CmbTables.ItemIndex := 0;
  CmbTables.OnEnter(Self);
  First_Prompt := false;
end;

procedure TForm1.checkAndPutEditText;
var
  whereisfrom: integer;
begin
  with Form1 do
    begin
      whereisfrom := Pos('from', LowerCase(MemoSQL.Text));
      intoFileName := Trim(copy(MemoSQL.Text, whereisfrom + 5, 20));
      if Pos(' ', intoFileName) > 0 then
        intoFileName := Trim(copy(intoFileName, 1, Pos(' ', intoFileName)));
      if (ChBEachRow.Checked)
        and (Trim(EdInsertInto.Text) = '') and (Trim(EdValues.Text) = '') then
        begin
          EdInsertInto.Text := 'insert into ';
          if whereisfrom > 0 then
            begin
              EdInsertInto.Text := EdInsertInto.Text + copy(MemoSQL.Text, whereisfrom + 5, 7);
            end;
          EdValues.Text := 'values';
          ChBLeftBrace.Checked := true;
          ChBRightBrace.Checked := true;
        end;
      if (Length(EdInsertInto.Text) > 0) and (Pos(intoFileName, EdInsertInto.Text) = 0) then
        EdInsertInto.Text := copy(EdInsertInto.Text, 1, Pos('into', EdInsertInto.Text) + 3)
          + ' ' + intoFileName;
    end;
end;

procedure TForm1.ChBEachRowClick(Sender: TObject);
begin
  checkAndPutEditText;
end;

procedure TForm1.CmbTablesEnter(Sender: TObject);
var
  index: integer;
  temp_str: string;
begin
  with query1 do
    begin
      DBImage1.DataField := ''; DBImage1.AutoDisplay := false;
      close;
      sql.text := 'select * from ' + CmbTables.text + ' where 1=2';
      try
        open;
        LabelFieldCnt.Caption := inttostr(FieldCount);
        MemoFields.Clear;
        for index := FieldCount - 1 downto 0 do
          begin
            temp_str := Fields[index].FieldName;
            temp_str := temp_str + #09 + TFieldTypeToStr(Fields[index].datatype);
            temp_str := temp_str + '(' + inttostr(Fields[index].datasize) + ')';
            MemoFields.Lines.Insert(0, temp_str);
          end;
        close;
        sql.text := 'select count(*) as rec_cnt from ' + CmbTables.text;
        open;
        LabelRecCnt.Caption := inttostr(FieldByName('rec_cnt').AsInteger);
        close;
      except
        on e: exception do ShowMessage(e.Message);
      end;
    end;
  if (not First_Prompt) and (Pos(CmbTables.text, MemoSQL.Text) = 0) then
    MemoSQL.Lines.Add('select * from ' + CmbTables.text);
end;

procedure TForm1.CmbTablesKeyPress(Sender: TObject; var Key: Char);
begin
  LabelFieldCnt.Caption := 'Ord(' + Key + ')=' + IntToStr(Ord(Key));
  if Key = Chr(13) then LabelFieldCnt.Caption := 'Ord( )=' + IntToStr(Ord(Key));
  LabelFieldCnt.Caption := LabelFieldCnt.Caption + ' = Hex(' + IntToHex(Ord(Key), 2) + ')';
  if Key = Chr(13) then CmbTables.OnEnter(Self);
//  MessageDlg(Key + ' has been pressed', mtInformation, [mbOK], 0)
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SetFormComboBoxDropDownCount(Self, 20);
  Form1.ComboBox1Change(Self);
  DataBase1.Session.GetAliasNames(ComboBox1.items);
  if (FindWindow('T2ADM_REGISTER', nil) > 0) then ComboBox1.Items.Add('T2Admin');
end;

procedure TForm1.MemoSQLExit(Sender: TObject);
begin
  MemoSQL.Font.Style := [];
end;

procedure TForm1.MemoSQLEnter(Sender: TObject);
begin
  MemoSQL.Font.Style := [fsBold];
end;

procedure TForm1.MemoFieldsEnter(Sender: TObject);
begin
  MemoFields.Font.Style := [fsBold];
end;

procedure TForm1.MemoFieldsExit(Sender: TObject);
begin
  MemoFields.Font.Style := [];
end;

procedure TForm1.MemoOutputEnter(Sender: TObject);
begin
  MemoOutput.Font.Style := [fsBold];
end;

procedure TForm1.MemoOutputExit(Sender: TObject);
begin
  MemoOutput.Font.Style := [];
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  try
    if (ComboBox1.Text = 'T2Admin') then
      begin
        LoginAdm := CreateOleObject('T2Admin.LoginManager');
        USER_ID := LoginAdm.GetAPUserID;
        USER_NAME := LoginAdm.GetAPUserName; //ȮɥHUser_IDϥΪ̦W
        IP_ADDRESS := LoginAdm.GetLocalIPAddress;
        SVR_NAME := LoginAdm.GetConnectServer;
        FDatabase := LoginAdm.GetDataBaseType;
        PASSWORD := LoginAdm.GetAPUserPassword;
        try
          if Database1.Connected then Database1.Close;
          with Database1 do
            begin
              LoginPrompt := false;
              Database1.DatabaseName := ComboBox1.Text;
              Database1.AliasName := '';
              DriverName := LoginAdm.GetDataBaseType;
              Params.Values['SERVER NAME'] := LoginAdm.GetConnectServer;
              Params.Values['HOST NAME'] := LoginAdm.GetLocalHostName;
              Params.Values['USER NAME'] := LoginAdm.GetConnectUserID;
              Params.Values['PASSWORD'] := LoginAdm.GetConnectPassword;
              Params.Values['APPLICATION NAME'] := set_Databases_Params_APPLICATIONNAME(
                Application.ExeName, User_ID, User_NAME);
{20090702 by wya for debug}
              if true then
                begin
                  SetClipbordMessage(
                    'Database1.DatabaseName=' + Database1.DatabaseName
                    + ' Database1.AliasName=' + Database1.AliasName
                    + ' Database1.LoginPrompt=' + BooleanToString(Database1.LoginPrompt) + #13#10
                    + 'Database1.Params.Text:' + #13#10 + Database1.Params.Text
                    );
                  ShowAndSetClipbordMessage(getClipbordMessage);
                end;
{20090702 by wya for debug}
              Connected := True;
            end;
          DB_databasename := Database1.DatabaseName;
        except
          on E: Exception do
            begin
              MessageDlg('LksƮw.(' + E.message + ')', mtError, [mbOK], 0);
              Application.Terminate; //_{
            end;
        end;
      end
    else
      Database1.LoginPrompt := true;
    DBImage1.DataField := '';
    DBImage1.AutoDisplay := false;
    DBGrid1.Enabled := false;
    if not (ComboBox1.Text = 'T2Admin') then
      begin
        DataBase1.Connected := false;
        Database1.AliasName := ComboBox1.Text;
        DataBase1.DatabaseName := combobox1.text;
        DataBase1.Connected := true;
      end;
    Query1.DatabaseName := DataBase1.DatabaseName;
    Form1.Formshow(Self);
    Form1.ButtonClearSQL.Click;

//    DataBase1.Session.GetTableNames(ComboBox1.text,'',false,false, CmbTables.items);
//    CmbTables.ItemIndex:=0;
//    CmbTables.OnClick(Self);
  except
    on e: exception do
      begin
        ShowMessage(e.Message);
        ComboBox1.text := ori_database;
        ComboBox1.SetFocus;
      end;
  end;
end;

procedure TForm1.stringsCopyToClipbrd(in_strings: string);
var
  tmpRichEdit: TRichEdit;
begin
  try
    tmpRichEdit := TRichEdit.Create(nil);
    with tmpRichEdit do
      begin
        Parent := self;
        Clear;
        Text := in_strings;
        SelectAll;
        CopyToClipboard;
        Free;
      end;
  except
    on e: exception do ShowMessage(e.Message);
  end;
end;

procedure TForm1.stringsPasteFromClipbrd;
var
  tmpRichEdit: TRichEdit;
begin
  try
    tmpRichEdit := TRichEdit.Create(nil);
    with tmpRichEdit do
      begin
        Parent := self;
        Clear;
//        Text:=in_strings;
        SelectAll;
        CopyToClipboard;
        Free;
      end;
  except
    on e: exception do ShowMessage(e.Message);
  end;
end;

procedure TForm1.MemoOutputCopyToClipbrd;
begin
  RichEditClipbrd.Clear;
  RichEditClipbrd.Text := MemoOutput.Text;
  RichEditClipbrd.SelectAll;
  RichEditClipbrd.CopyToClipboard;
end;

procedure TForm1.MemoOutputPasteFromClipboard;
begin
  RichEditClipbrd.PasteFromClipboard;
  RichEditClipbrd.SelectAll;
  MemoOutput.Lines.Append(RichEditClipbrd.Text);
end;

procedure TForm1.MemoOutputDblClick(Sender: TObject);
begin
  MemoOutputPasteFromClipboard;
end;

procedure TForm1.MemoOutputMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
//  if Button=mbRight then MemoOutputCopyToClipbrd;
  if Button = mbRight then stringsCopyToClipbrd(MemoOutput.Text);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
//var shift_byte:byte;
begin
  if (ComboBox1.Text = 'T2Admin') then
    Caption := 'ʺAadߵGনr ' + Application.ExeName + ' Server[' + SVR_NAME + ']'
      + ' User[' + User_ID + ']' + ' {:' + FormatDateTime('yyyy/mm/dd hh:mm'
      , FileDateToDateTime(FileGetDate(FileOpen(Application.exename, fmShareDenyNone))))
      + ' ' + DateTimeToStr2(now)
  else
    Caption := 'ʺAadߵGনr With Server:['
      + Database1.AliasName + ']' + ' ' + DateTimeToStr2(now);
{
//  StatusBar1.SimpleText:=DateTimeToStr(Now);
  StatusBar1.SimpleText:=FormatDateTime('yyyy/mm/dd hh:mm:ss',now);
//  if IsDBCSLeadByte(copy(Form1.Caption,1,1)) and
//    not IsDBCSLeadByte(copy(Form1.Caption,2,1)) then shift_byte:=2
  if (ByteType(Form1.Caption,1)=mbleadbyte) and
    (ByteType(Form1.Caption,2)=mbTrailByte) then shift_byte:=2
  else shift_byte:=1;
  Form1.Caption:=copy(Form1.Caption,shift_byte+1,length(Form1.Caption)-shift_byte)+copy(Form1.Caption,1,shift_byte);
}
end;

procedure TForm1.mnuSQLOutClick(Sender: TObject);
begin
  ShowSQLAndSetClipbordMessage(TQuery(DBGrid1.DataSource.DataSet));
end;

procedure TForm1.mnuSetGridClick(Sender: TObject);
begin
  SetGridShow(DBGrid1);
end;

procedure TForm1.mnuDataOutClick(Sender: TObject);
begin
  SetClipbordMessage(ReplaceFromString(
    GetDatasetAndSetClipbordMessage(DBGrid1.DataSource.DataSet, '|')
    + #13#10, #13#10#13#10, #13#10));
  ShowMessage(copy(getClipbordMessage, 1, 200) + ' ...');
end;

procedure TForm1.mnuExcelOutClick(Sender: TObject);
begin
  if DBGrid1.DataSource.DataSet.Active then
    begin
      SaveDialog1.DefaultExt := '.xls';
      SaveDialog1.Filter := '*.xls|*.xls|*.*|*.*';
      if SaveDialog1.Execute then
        DataSetToExcel(DBGrid1.DataSource.DataSet, SaveDialog1.FileName, false, false, false
          , 60000, Database1.AliasName, '', ProgressBar1);
//        DataSetToXLS(DBGrid1.DataSource.DataSet, SaveDialog1.FileName, false);
    end;
end;

end.

