unit SetGrid;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, db, wwDbLook, dbTables,
  StdCtrls, ExtCtrls, Forms, checklst, wwdbgrid, Dialogs, wwQuery, ComCtrls, comlib
  , wwTomDbGrid, Grids;

type
  TfrmSetGrid = class(TForm)
    Button1: TButton;
    Button2: TButton;
    FieldList: TCheckListBox;
    StringGrid1: TStringGrid;
    CheckBox1: TCheckBox;
    Button3: TButton;
    ComboBox1: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FieldListDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FieldListDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FormResize(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox1Click(Sender: TObject);
    procedure StringGrid1RowMoved(Sender: TObject; FromIndex,
      ToIndex: Integer);
    procedure StringGrid1SelectCell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure Button3Click(Sender: TObject);
  private
  public
  end;

procedure SetTwwTomDbGridShow(var TmpGrid1: TwwTomDbGrid);
procedure SetGridShow(var TmpGrid1: TwwDbGrid);

function GetField(Sender: TWinControl; FieldIndex: Integer): TField;
//procedure SetWidth(Sender : TCustomEdit; Font : TFont; StrLeng, MaxWidth : Integer);
procedure ExchangeField(Sender: TwwDBLookUpCombo);
procedure LookUpComboChange(Sender: TwwDbLookUpCombo; OutPut: TLabel; MaxLength: Integer);
function GetCode(Sender: TwwDbLookUpCombo): string;

implementation
{$R *.DFM}
var
  frmSetGrid: TfrmSetGrid;
  Grid1: TwwDbGrid;
  isTomDBGrid: Boolean;

procedure SetTwwTomDbGridShow(var TmpGrid1: TwwTomDbGrid);
begin
  frmSetGrid := TfrmSetGrid.Create(Application);
{20060620 by wya for debug
  ShowAndSetClipbordMessage(
    'TmpGrid1.Fields[0].DisplayName =' + TmpGrid1.Fields[0].DisplayName + #13#10
    + 'TmpGrid1.Fields[0].DisplayLabel=' + TmpGrid1.Fields[0].DisplayLabel + #13#10
    + 'TmpGrid1.Fields[0].DisplayText =' + TmpGrid1.Fields[0].DisplayText + #13#10
    + 'TmpGrid1.Fields[0].FieldName   =' + TmpGrid1.Fields[0].FieldName + #13#10
    + 'TmpGrid1.Fields[0].DisplayWidth=' + inttostr(TmpGrid1.Fields[0].DisplayWidth) + #13#10
    + 'TmpGrid1.Fields[0].Name        =' + TmpGrid1.Fields[0].Name + #13#10
    + 'TmpGrid1.Selected.Text:' + #13#10 + TmpGrid1.Selected.Text
    );
20060620 by wya for debug}
  isTomDBGrid := true;
  try
    Grid1 := TwwDBGrid(tmpGrid1);
    if (not Grid1.DataSource.DataSet.Active) then exit;
//    frmSetGrid.Caption := '(' + Tform(Grid1.Parent).Name + ')]w';
    frmSetGrid.Caption := '(' + Grid1.DataSource.DataSet.Name + ')]w';
    frmSetGrid.SHowModal;
  finally
    frmSetGrid.Free;
  end;
end;

procedure SetGridShow(var TmpGrid1: TwwDbGrid);
begin
  frmSetGrid := TfrmSetGrid.Create(Application);
  isTomDBGrid := false;
  try
    Grid1 := TwwDBgrid(tmpGrid1);
    if (not Grid1.DataSource.DataSet.Active) then exit;
//    frmSetGrid.Caption := '(' + Tform(Grid1.Parent).Name + ')]w';
    frmSetGrid.Caption := '(' + Grid1.DataSource.DataSet.Name + ')]w';
    frmSetGrid.SHowModal;
  finally
    frmSetGrid.Free;
  end;
end;

procedure TfrmSetGrid.FormShow(Sender: TObject);
var
  i: integer;
  wk_index: integer;
  wk_str: string;
begin
  with StringGrid1 do
    begin
      ColCount := 5;
      RowCount := Grid1.DataSource.DataSet.FieldCount + 1;
      FixedCols := 2;
      FixedRows := 1;
      Cells[0, 0] := '';
      Cells[1, 0] := 'W';
      Cells[2, 0] := '';
      Cells[3, 0] := 'e';
      Cells[4, 0] := 'ܦW';
      ColWidths[0] := 24;
      ColWidths[1] := 100;
      ColWidths[2] := 20;
      ColWidths[3] := 30;
      ColWidths[4] := 120;
    end;
  wk_index := 0;
  for i := 0 to Grid1.FieldCount - 1 do
    begin
      inc(wk_index);
      StringGrid1.Cells[0, wk_index] := inttostr(wk_index);
      StringGrid1.Cells[2, wk_index] := '';
      if (Grid1.Selected.Count > i) then
        wk_str := Grid1.Selected.Strings[i]
      else
        wk_str := Grid1.Fields[i].FieldName + #9 + inttostr(Grid1.Fields[i].Size) + #9 + Grid1.Fields[i].FieldName;
      StringGrid1.Cells[1, wk_index] := copy(wk_str, 0, pos(#9, wk_str) - 1);
      wk_str := copy(wk_str, pos(#9, wk_str) + 1, length(wk_str));
      StringGrid1.Cells[3, wk_index] := copy(wk_str, 0, pos(#9, wk_str) - 1);
      wk_str := copy(wk_str, pos(#9, wk_str) + 1, length(wk_str));
      StringGrid1.Cells[4, wk_index] := wk_str;
{20060620 by wya for debug
      if (i = 0) then
        begin
          ShowAndSetClipbordMessage(
            'BooleanToString(isTomDBGrid)=' + BooleanToString(isTomDBGrid) + #13#10
            + 'Grid1.Selected.Strings[' + inttostr(i) + ']=' + Grid1.Selected.Strings[i] + #13#10
            + 'StringGrid1.Cells[1, ' + inttostr(wk_index) + ']=' + StringGrid1.Cells[1, wk_index] + #13#10
            + 'StringGrid1.Cells[3, ' + inttostr(wk_index) + ']=' + StringGrid1.Cells[3, wk_index] + #13#10
            + 'StringGrid1.Cells[4, ' + inttostr(wk_index) + ']=' + StringGrid1.Cells[4, wk_index] + #13#10
            );
        end;
20060620 by wya for debug}

      FieldList.Items.Add(Grid1.Fields[i].DisplayLabel);
      FieldList.Checked[i] := True;
    end;
  for i := 0 to Grid1.DataSource.DataSet.FieldCount - 1 do
    begin
      if FieldList.Items.IndexOf(Grid1.DataSource.DataSet.Fields[i].DisplayLabel) = -1 then
        begin
          inc(wk_index);
          StringGrid1.Cells[0, wk_index] := inttostr(wk_index);
          StringGrid1.Cells[1, wk_index] := Grid1.DataSource.DataSet.Fields[i].FieldName;
          StringGrid1.Cells[2, wk_index] := '';
          StringGrid1.Cells[3, wk_index] := inttostr(Grid1.DataSource.DataSet.Fields[i].datasize);
          StringGrid1.Cells[4, wk_index] := Grid1.DataSource.DataSet.Fields[i].DisplayLabel;

          FieldList.Items.Add(Grid1.DataSource.DataSet.Fields[i].DisplayLabel);
        end;
    end;
{20060620 by wya for debug
  ShowAndSetClipbordMessage(
    'BooleanToString(isTomDBGrid)=' + BooleanToString(isTomDBGrid) + #13#10
//    + 'Grid1.Fields[0].DisplayName =' + Grid1.Fields[0].DisplayName + #13#10
//    + 'Grid1.Fields[0].DisplayLabel=' + Grid1.Fields[0].DisplayLabel + #13#10
//    + 'Grid1.Fields[0].DisplayText =' + Grid1.Fields[0].DisplayText + #13#10
//    + 'Grid1.Fields[0].FieldName   =' + Grid1.Fields[0].FieldName + #13#10
//    + 'Grid1.Fields[0].DisplayWidth=' + inttostr(Grid1.Fields[0].DisplayWidth) + #13#10
//    + 'Grid1.Fields[0].Name        =' + Grid1.Fields[0].Name + #13#10
//    + 'Grid1.Fields[1].DisplayName =' + Grid1.Fields[1].DisplayName + #13#10
//    + 'Grid1.Fields[1].DisplayLabel=' + Grid1.Fields[1].DisplayLabel + #13#10
//    + 'Grid1.Fields[1].DisplayText =' + Grid1.Fields[1].DisplayText + #13#10
//    + 'Grid1.Fields[1].FieldName   =' + Grid1.Fields[1].FieldName + #13#10
//    + 'Grid1.Fields[1].DisplayWidth=' + inttostr(Grid1.Fields[1].DisplayWidth) + #13#10
//    + 'Grid1.Fields[1].Name        =' + Grid1.Fields[1].Name + #13#10
    + 'Grid1.Selected.Text:' + #13#10 + Grid1.Selected.Text
    );
20060620 by wya for debug}
  CheckBox1Click(Sender);
end;

procedure TfrmSetGrid.Button1Click(Sender: TObject);
var
  i, j: integer;
begin
  Grid1.Selected.Clear;
  if FieldList.Visible then
    begin
      with TwwQuery(Grid1.DataSource.DataSet) do
        begin
          for i := 0 to FieldList.Items.Count - 1 do
            begin
              if FieldList.Checked[i] then
                begin
                  for j := 0 to FieldCount - 1 do
                    begin
                      if fields[j].DisplayLabel = FieldList.Items.Strings[i] then
                        begin
                          Grid1.Selected.Add(fields[j].FieldName + chr(9)
                            + intToStr(fields[j].DisplayWidth) + chr(9) + fields[j].DisplayLabel);
                          break;
                        end;
                    end;
                end;
            end;
        end;
    end
  else
    begin
      with TwwQuery(Grid1.DataSource.DataSet) do
        begin
          for i := 1 to StringGrid1.RowCount do
            if (StringGrid1.Cells[2, i] = '') and (strtoint(StringGrid1.Cells[3, i]) > 0) then
              for j := 0 to FieldCount - 1 do
                if (fields[j].FieldName = StringGrid1.Cells[1, i]) then
                  begin
                    Grid1.Selected.Add(StringGrid1.Cells[1, i] + #9
                      + trim(inttostr(strtoint(StringGrid1.Cells[3, i]))) + #9 + StringGrid1.Cells[4, i]);
                    break;
                  end;
//20060803 by wya add down 1 line
          if false then
            for i := 1 to StringGrid1.RowCount do
              if (StringGrid1.Cells[2, i] <> '') or (strtoint(StringGrid1.Cells[3, i]) <= 0) then
                for j := 0 to FieldCount - 1 do
                  if (fields[j].FieldName = StringGrid1.Cells[1, i]) then
                    begin
                      if isTomDBGrid then
                        Grid1.Selected.Add(StringGrid1.Cells[1, i] + #9
                          + '0' + #9 + StringGrid1.Cells[4, i])
                      else
                        Grid1.Selected.Add(StringGrid1.Cells[1, i] + #9
                          + '0' + #9 + StringGrid1.Cells[4, i]);
                      break;
                    end;
        end;
    end;
  Grid1.ApplySelected;
  Grid1.RedrawGrid;
  Grid1.RefreshDisplay;
{20060620 by wya for debug
  ShowAndSetClipbordMessage(
    'BooleanToString(isTomDBGrid)=' + BooleanToString(isTomDBGrid) + #13#10
    + 'Grid1.Selected.Text:' + #13#10 + Grid1.Selected.Text
    );
20060620 by wya for debug}
end;

procedure TfrmSetGrid.FieldListDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  a: Tpoint;
  check: Boolean;
  Index: Integer;
begin
  a.x := X;
  a.y := Y;
  check := FieldList.checked[FieldList.ItemIndex];
  if FieldList.ItemAtPos(a, true) = -1 then
    Index := FieldList.Items.Count - 1
  else
    Index := FieldList.ItemAtPos(a, true);
  FieldList.Items.Move(FieldList.ItemIndex, Index);
  FieldList.checked[Index] := check;
end;

procedure TfrmSetGrid.FieldListDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := True;
end;

function GetField(Sender: TWinControl; FieldIndex: Integer): TField;
var
  SelList: Tstrings;
  aDataSet: TDataSet;
  I: Integer;
  S: string;
begin
  Result := nil;
  if (Sender is TwwDbGrid) or (Sender is TwwTomDbGrid) then
    begin
      SelList := TwwDbGrid(Sender).Selected;
      aDataSet := TwwDbGrid(Sender).DataSource.DataSet;
    end
  else
    if Sender is TwwDbLookUpCombo then
      begin
        SelList := TwwDbLookUpCombo(Sender).Selected;
        aDataSet := TwwDbLookUpCombo(Sender).LookUpTable;
      end
    else
      exit;
  I := Pos(#9, SelList.Strings[FieldIndex]) - 1;
  S := Copy(SelList.Strings[FieldIndex], 1, I);
  Result := aDataSet.FieldByName(S);
end;

procedure SetWidth(Sender: TCustomEdit; Font: TFont; StrLeng, MaxWidth: Integer);
var
  FWidth: Integer;
begin
  FWidth := Round((Font.Size + 0.6263) * StrLeng * 0.8);
  if (FWidth < MaxWidth) or (MaxWidth <= 0) then
    Sender.ClientWidth := FWidth
  else
    Sender.ClientWidth := MaxWidth;
end;

procedure ExchangeField(Sender: TwwDBLookUpCombo);
var
  SelList: TStrings;
  I: Integer;
  FField: TField;
  FName, FValue: string;
begin
  SelList := TStringList.Create;
  try
    Sender.LookupTable.DisableControls;
    FName := Sender.LookupField;
    FValue := GetCode(Sender);
    SelList.Add(Sender.Selected.Strings[1]);
    SelList.Add(Sender.Selected.Strings[0]);
    for I := 2 to SelList.Count - 1 do
      SelList.Add(Sender.Selected.Strings[I]);
    Sender.Selected.Clear;
    Sender.Selected.Text := SelList.Text;
    FField := GetField(Sender, 0);
    with TQuery(Sender.LookupTable) do
      begin
        Close;
        SQL.Strings[SQL.Count - 1] := 'order by ' + FField.FieldName;
        Open;
        Sender.RefreshDisplay;
        if FValue <> '' then
          try
            if Locate(FName, FValue, [loCaseInsensitive]) then
              Sender.Text := FieldByName(FField.FieldName).AsString
            else
              Sender.Text := '';
          except
            Sender.Text := '';
          end
        else
          Sender.Text := '';
        if Assigned(Sender.OnChange) then Sender.OnChange(Sender);
      end;
  finally
    Sender.LookupTable.EnableControls;
    SelList.Free;
  end;

end;

procedure LookUpComboChange(Sender: TwwDbLookUpCombo; OutPut: TLabel; MaxLength: Integer);
var
  Field1, Field2: TField;
  F1, F2: Integer;
begin
  Field1 := GetField(Sender, 0);
  Field2 := GetField(Sender, 1);
  F1 := Field1.DisplayWidth;
  F2 := Field2.DisplayWidth;
  if F1 > F2 then
    F1 := MaxLength - 35 - Round((OutPut.Font.Size + 0.6263) * F2 * 0.8)
  else
    F1 := Round((Sender.Font.Size + 0.6263) * F1 * 0.8);
  Sender.ClientWidth := F1;
  OutPut.Left := Sender.Left + Sender.Width + 10;
  Output.Caption := '';
  if Sender.Text <> '' then
    if Sender.LookupTable.Locate(Field1.FieldName, Sender.Text, []) then
      OutPut.Caption := Sender.LookUpTable.FieldByName(Field2.FieldName).AsString;
end;

function GetCode(Sender: TwwDbLookUpCombo): string;
begin
  if Sender.Text = '' then
    Result := ''
  else
    Result := Sender.LookupTable.FieldByName(Sender.LookUpField).AsString;
end;

procedure TfrmSetGrid.FormResize(Sender: TObject);
begin
  FieldList.Top := 0;
  FieldList.Left := 0;
  FieldList.Height := frmSetGrid.Height - FieldList.Top - Button1.Height - 6 - 26;
  FieldList.Width := frmSetGrid.Width - FieldList.Left - 10;
  Button1.Top := frmSetGrid.Height - Button1.Height - 4 - 26;
  Button2.Top := Button1.Top;
  CheckBox1.Top := frmSetGrid.Height - CheckBox1.Height - 4 - 26;
  StringGrid1.Top := FieldList.Top;
  StringGrid1.Left := FieldList.Left;
  StringGrid1.Height := FieldList.Height;
  StringGrid1.Width := FieldList.Width;
  ComboBox1.Top := Button1.Top;
  Button3.Top := Button1.Top;
  ComboBox1.ItemIndex := 0;
end;

procedure TfrmSetGrid.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
{20060619 by wya for debug
  ShowAndSetClipbordMessage(
    'frmSetGrid.Top=' + inttostr(frmSetGrid.Top) + #13#10
    + 'frmSetGrid.Left=' + inttostr(frmSetGrid.Left) + #13#10
    + 'frmSetGrid.Width=' + inttostr(frmSetGrid.Width) + #13#10
    + 'frmSetGrid.Height=' + inttostr(frmSetGrid.Height) + #13#10
    + 'FieldList.Top=' + inttostr(FieldList.Top) + #13#10
    + 'FieldList.Left=' + inttostr(FieldList.Left) + #13#10
    + 'FieldList.Width=' + inttostr(FieldList.Width) + #13#10
    + 'FieldList.Height=' + inttostr(FieldList.Height) + #13#10
    + 'Button1.Top=' + inttostr(Button1.Top) + #13#10
    + 'Button1.Left=' + inttostr(Button1.Left) + #13#10
    + 'Button1.Width=' + inttostr(Button1.Width) + #13#10
    + 'Button1.Height=' + inttostr(Button1.Height) + #13#10
    + 'Button2.Top=' + inttostr(Button2.Top) + #13#10
    + 'Button2.Left=' + inttostr(Button2.Left) + #13#10
    + 'Button2.Width=' + inttostr(Button2.Width) + #13#10
    + 'Button2.Height=' + inttostr(Button2.Height) + #13#10
    );
20060619 by wya for debug}
end;

procedure TfrmSetGrid.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
    begin
      FieldList.Visible := false;
      StringGrid1.Visible := true;
    end
  else
    begin
      FieldList.Visible := true;
      StringGrid1.Visible := false;
    end;
end;

procedure TfrmSetGrid.StringGrid1RowMoved(Sender: TObject; FromIndex,
  ToIndex: Integer);
var
  wk_index: integer;
begin
  for wk_index := 1 to StringGrid1.RowCount do
    StringGrid1.Cells[0, wk_index] := inttostr(wk_index);
end;

procedure TfrmSetGrid.StringGrid1SelectCell(Sender: TObject; Col,
  Row: Integer; var CanSelect: Boolean);
begin
  if Col = 2 then
    begin
      if (StringGrid1.Cells[Col, Row] = '') then
        StringGrid1.Cells[Col, Row] := ''
      else
        StringGrid1.Cells[Col, Row] := '';
      StringGrid1.SetFocus;
    end;
end;

procedure TfrmSetGrid.Button3Click(Sender: TObject);
begin
  SetClipbordMessage(GetStringgridAndSetClipbordMessage(StringGrid1, ComboBox1.Text));
end;

end.

