// {ӷ http://delphi.ktop.com.tw
// @:Yudi Wibisono XLSFILE
// CCCHEN:אּFunction
// Ѩ:

unit XLSFile;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, db,
  dbctrls, comctrls, grids, comlib, dbTables, comobj;

const
{BOF}
  CBOF = $0009;
  BIT_BIFF5 = $0800;
  BOF_BIFF5 = CBOF or BIT_BIFF5;
{EOF}
  BIFF_EOF = $000A;
{Document types}
  DOCTYPE_XLS = $0010;
{Dimensions}
  DIMENSIONS = $0000;
{MAXWORD}
  MAXWORD = 65536;

type
  TAtributCell = (acHidden, acLocked, acShaded, acBottomBorder, acTopBorder,
    acRightBorder, acLeftBorder, acLeft, acCenter, acRight, acFill);

  TSetOfAtribut = set of TatributCell;

  TXLSWriter = class(Tobject)
  private
    fstream: TFileStream;
    procedure WriteWord(w: word);
  protected
    procedure WriteBOF;
    procedure WriteEOF;
    procedure WriteDimension;
  public
    maxCols, maxRows: Word;

    procedure CellWord(vCol, vRow: word; aValue: word; vAtribut: TSetOfAtribut);
    procedure CellDouble(vCol, vRow: word; aValue: double; vAtribut: TSetOfAtribut);
    procedure CellStr(vCol, vRow: word; aValue: string; vAtribut: TSetOfAtribut);

    procedure WriteField(vCol, vRow: word; Field: TField);
    constructor create(vFileName: string; checkExist: boolean);
    destructor destroy; override;
  end;

procedure SetCellAtribut(value: TSetOfAtribut; var FAtribut: array of byte);
procedure DataSetToXLS(ds: TDataSet; fname: string; checkExist: boolean);
procedure StringGridToXLS(ds: TStringGrid; fname: string; checkExist: boolean; AutoTrans: boolean);
procedure DataSetToExcel(In_DataSet: TDataSet; fname: string; checkExist, WantOpen, showSQLStr: boolean;
  RecordPerSheet: word; SVR_Name, In_FieldDesc: string; var Upd_PgsBar: TProgressBar);
function Excel_get_Field_Value(in_field: TField; shownull: boolean): AnsiString;

implementation

function Excel_get_Field_Value(in_field: TField; shownull: boolean): AnsiString;
begin
  if in_field.IsNull and not shownull then
    Result := ''
  else
    Result := get_Field_Value(in_field);
  if not is_Field_Type_Numeric(in_field) and (is_Field_Value_Numeric(in_field)
    or is_Field_Value_Date(in_field)) then Result := #27 + Result;
end;

procedure DataSetToExcel(In_DataSet: TDataSet; fname: string; checkExist, WantOpen, showSQLStr: boolean;
  RecordPerSheet: word; SVR_Name, In_FieldDesc: string; var Upd_PgsBar: TProgressBar);
var
  col, row, current, recordbegin: Integer;
  MsExcel, MsExcelWorkBook, MsExcelWorkSheet: Variant; bfile_exist: boolean;
begin
  bfile_exist := FileExists(fname);
  try
    MsExcel := CreateOleObject('Excel.Application');
    if VarIsNull(MsExcel) then exit;
    if (RecordPerSheet = 0) then RecordPerSheet := 60000;
    try
      MsExcel.Visible := false;
      if bfile_exist then
        begin
          MsExcel.displayalerts := false;
          MsExcelWorkBook := MsExcel.WorkBooks.Open(fname, readonly := false);
        end
      else
        begin
          MsExcel.WorkBooks.add(1);
          MsExcelWorkBook := MsExcel.WorkBooks[1];
        end;
      MsExcelWorkSheet := MsExcelWorkBook.ActiveSheet;
      row := 1;
      addxlsSQLsheet(showSQLStr, In_DataSet, RecordPerSheet, SVR_Name, MsExcelWorkBook
        , MsExcelWorkSheet, row);
      if (In_DataSet.RecordCount > RecordPerSheet) then
        rename_xlssheet('Rcd#' + inttostr(1), MsExcelWorkSheet)
      else
        rename_xlssheet(SVR_Name, MsExcelWorkSheet);
      writexlsFieldName(In_FieldDesc, In_DataSet, MsExcelWorkSheet, row);

      inc(row);
      In_DataSet.first; current := 0; recordbegin := 1;
      Upd_PgsBar.Min := 0; Upd_PgsBar.Max := In_DataSet.RecordCount;
      Upd_PgsBar.Position := 0; Upd_PgsBar.Update;
      while not In_DataSet.eof do
        begin
          Upd_PgsBar.StepBy(1); Upd_PgsBar.Update;
          inc(current);
          for col := 1 to In_DataSet.FieldCount do
            begin
              if true then
                set_Excel_Value_From_Field(MsExcelWorkSheet, row, col
                  , In_DataSet.Fields[col - 1], false)
              else
                MsExcelWorkSheet.cells[row, col] := Excel_get_Field_Value(In_DataSet.Fields[col - 1], false);
            end;
          if (current < In_DataSet.RecordCount) and ((current mod RecordPerSheet) = 0) then
            begin
              if (MsExcelWorkBook.sheets.count > 254) then
                begin
                end;
              addxlssheet(false, current, recordbegin, MsExcelWorkBook, MsExcelWorkSheet);
              row := 1;
              writexlsFieldName(In_FieldDesc, In_DataSet, MsExcelWorkSheet, row);
            end;
          inc(row);
          In_DataSet.next;
        end;
      Upd_PgsBar.Position := Upd_PgsBar.Max; Upd_PgsBar.Update;
      addxlssheet(true, current, recordbegin, MsExcelWorkBook, MsExcelWorkSheet);
      set_Excel_WrapText(MsExcelWorkSheet, 0, 0, false);
      if bfile_exist then
        begin
          if checkExist then
            if (MessageDlg('ɮ[' + fname + ']wsb, nл\?!', mtConfirmation, mbOKCancel, 0)
              = mrCancel) then
              begin
                MsExcel.visible := true; exit;
              end;
        end;
      MsExcelWorkBook.SaveAs(FileName := fname);

      if WantOpen then
        begin
          MsExcelWorkBook.close;
          MsExcelWorkBook := MsExcel.WorkBooks.Open(fname, readonly := false);
          MsExcel.visible := true;
        end
      else
        MsExcel.Quit;
    except
      MsExcelWorkBook.SaveAs(FileName := fname);
      MsExcel.Quit;
    end;
  finally
  end;
end;

procedure StringGridToXLS(ds: TStringGrid; fname: string; checkExist: boolean; AutoTrans: boolean);
var
  c, r: Integer;
  xls: TXLSWriter;
  ValueType: Byte;
  iValue: Integer;
  fValue: Double;
begin
  xls := TXLSWriter.create(fname, checkExist);
  if (xls.fstream = nil) then exit;
//{20061023 by wya for debug} ShowMessage('StringGridToXLS-1');
  if ds.ColCount > xls.maxcols then xls.maxcols := ds.ColCount + 1;
  try
    xls.writeBOF;
    xls.WriteDimension;
    r := 0;
    while (r < ds.RowCount) do
      begin
        for c := 0 to ds.ColCount - 1 do
          begin
            if AutoTrans then
              begin
                try
                  ValueType := 1;
                  iValue := StrToInt(ds.Cells[c, r]);
                  if (iValue > maxword) then ValueType := 0;
                except
                  ValueType := 0;
                end;
                if (ValueType = 0) then
                  begin
                    try
                      ValueType := 2;
                      fValue := StrTofloat(ds.Cells[c, r]);
                    except
                      ValueType := 0;
                    end;
                  end;
              end
            else
              ValueType := 0;
            case ValueType of
              0:
                xls.Cellstr(r, c, ds.Cells[c, r], []);
              1:
                xls.CellWord(r, c, iValue, []);
              2:
                xls.CellDouble(r, c, fValue, []);
            end;
          end;
        if r > xls.maxrows then
          begin
            xls.fstream.Seek(10, soFromBeginning);
            xls.WriteDimension;
          end;
        inc(r);
      end;
    xls.writeEOF;
  finally
    xls.free;
  end;
end;

procedure DataSetToXLS(ds: TDataSet; fname: string; checkExist: boolean);
var
  c, r: Integer;
  xls: TXLSWriter;
begin
  xls := TXLSWriter.create(fname, checkExist);
  if (xls.fstream = nil) then exit;
  if ds.FieldCount > xls.maxcols then xls.maxcols := ds.fieldcount + 1;
  try
    xls.writeBOF;
    r := 0;
    xls.WriteDimension;
    xls.Cellstr(r, 0, GetSQLAndSetClipbordMessage(TQuery(ds), false), []);
    inc(r);
    for c := 0 to ds.FieldCount - 1 do
      begin
        xls.Cellstr(r, c, ds.Fields[c].FieldName, []);
//        Form1.LabelFieldCnt.Caption := IntToStr(c + 1);
      end;
    inc(r);
    ds.first;
    while not ds.eof do
      begin
//        Form1.LabelRecNo.Caption := IntToStr(StrToInt(Form1.LabelRecNo.Caption) + 1);
        for c := 0 to ds.FieldCount - 1 do
          xls.WriteField(r, c, ds.Fields[c]);
        inc(r);
        ds.next;
      end;
    if r > xls.maxrows then
      begin
        xls.fstream.Seek(10, soFromBeginning);
        xls.WriteDimension;
      end;
    xls.writeEOF;
  finally
    xls.free;
  end;
end;

{ TXLSWriter }

constructor TXLSWriter.create(vFileName: string; checkExist: boolean);
begin
  inherited create;
  if FileExists(vFilename) then
    begin
      if checkExist then
        if (MessageDlg('ɮ[' + vFileName + ']wsb, nл\?!', mtConfirmation, mbOKCancel, 0) = mrCancel) then
          begin
            exit;
          end;
      fStream := TFileStream.Create(vFilename, fmOpenWrite)
    end
  else
    fStream := TFileStream.Create(vFilename, fmCreate);

  maxCols := 100;
  maxRows := 1000;
end;

destructor TXLSWriter.destroy;
begin
  if fStream <> nil then
    fStream.free;
  inherited;
end;

procedure TXLSWriter.WriteBOF;
begin
  Writeword(BOF_BIFF5);
  Writeword(6); //count of bytes
  Writeword(0);
  Writeword(DOCTYPE_XLS);
  Writeword(0);
end;

procedure TXLSWriter.WriteDimension;
begin
  Writeword(DIMENSIONS); // dimension OP Code
  Writeword(8); //count of bytes
  Writeword(0); // min cols
  Writeword(maxRows); // max rows
  Writeword(0); // min rowss
  Writeword(maxcols); // max cols
end;

procedure TXLSWriter.CellDouble(vCol, vRow: word; aValue: double; vAtribut: TSetOfAtribut);
var
  FAtribut: array[0..2] of byte;
begin
  Writeword(3); // opcode for double
  Writeword(15); // count of byte
  Writeword(vCol);
  Writeword(vRow);
  SetCellAtribut(vAtribut, fAtribut);
  fStream.Write(fAtribut, 3);
  fStream.Write(aValue, 8);
end;

procedure TXLSWriter.CellWord(vCol, vRow: word; aValue: word; vAtribut: TSetOfAtribut);
var
  FAtribut: array[0..2] of byte;
begin
  Writeword(2); // opcode for word
  Writeword(9); // count of byte
  Writeword(vCol);
  Writeword(vRow);
  SetCellAtribut(vAtribut, fAtribut);
  fStream.Write(fAtribut, 3);
  Writeword(aValue);
end;

procedure TXLSWriter.CellStr(vCol, vRow: word; aValue: string; vAtribut: TSetOfAtribut);
var
  FAtribut: array[0..2] of byte;
  slen: byte;
begin
  Writeword(4); // opcode for string
  slen := length(avalue);
  Writeword(slen + 8); // count of byte
  Writeword(vCol);
  Writeword(vRow);
  SetCellAtribut(vAtribut, fAtribut);
  fStream.Write(fAtribut, 3);
  fStream.Write(slen, 1);
  fStream.Write(aValue[1], slen);
end;

procedure SetCellAtribut(value: TSetOfAtribut; var FAtribut: array of byte);
var
  i: integer;
begin
 //reset
  for i := 0 to High(FAtribut) do
    FAtribut[i] := 0;

     {Byte Offset     Bit   Description                     Contents
     0          7     Cell is not hidden              0b
                      Cell is hidden                  1b
                6     Cell is not locked              0b
                      Cell is locked                  1b
                5-0   Reserved, must be 0             000000b
     1          7-6   Font number (4 possible)
                5-0   Cell format code
     2          7     Cell is not shaded              0b
                      Cell is shaded                  1b
                6     Cell has no bottom border       0b
                      Cell has a bottom border        1b
                5     Cell has no top border          0b
                      Cell has a top border           1b
                4     Cell has no right border        0b
                      Cell has a right border         1b
                3     Cell has no left border         0b
                      Cell has a left border          1b
                2-0   Cell alignment code
                           general                    000b
                           left                       001b
                           center                     010b
                           right                      011b
                           fill                       100b
                           Multiplan default align.   111b
     }

     //  bit sequence 76543210

  if acHidden in value then //byte 0 bit 7:
    FAtribut[0] := FAtribut[0] + 128;

  if acLocked in value then //byte 0 bit 6:
    FAtribut[0] := FAtribut[0] + 64;

  if acShaded in value then //byte 2 bit 7:
    FAtribut[2] := FAtribut[2] + 128;

  if acBottomBorder in value then //byte 2 bit 6
    FAtribut[2] := FAtribut[2] + 64;

  if acTopBorder in value then //byte 2 bit 5
    FAtribut[2] := FAtribut[2] + 32;

  if acRightBorder in value then //byte 2 bit 4
    FAtribut[2] := FAtribut[2] + 16;

  if acLeftBorder in value then //byte 2 bit 3
    FAtribut[2] := FAtribut[2] + 8;

  if acLeft in value then //byte 2 bit 1
    FAtribut[2] := FAtribut[2] + 1
  else
    if acCenter in value then //byte 2 bit 1
      FAtribut[2] := FAtribut[2] + 2
    else
      if acRight in value then //byte 2, bit 0 dan bit 1
        FAtribut[2] := FAtribut[2] + 3;
  if acFill in value then //byte 2, bit 0
    FAtribut[2] := FAtribut[2] + 4;
end;

procedure TXLSWriter.WriteWord(w: word);
begin
  fstream.Write(w, 2);
end;

procedure TXLSWriter.WriteEOF;
begin
  Writeword(BIFF_EOF);
  Writeword(0);
end;

procedure TXLSWriter.WriteField(vCol, vRow: word; Field: TField);
begin
  case field.DataType of
//     ftString,ftWideString,ftBoolean,ftDate,ftDateTime,ftTime:
    ftString, ftBoolean, ftDate, ftDateTime, ftTime:
//      Cellstr(vcol, vrow, field.asstring, []);
      Cellstr(vcol, vrow, get_Field_Value(Field), []);
    ftSmallint, ftInteger, ftWord:
      if (field.AsInteger <= maxword) then
        CellWord(vcol, vRow, field.AsInteger, [])
      else
        CellDouble(vcol, vrow, field.AsFloat, []);
    ftFloat, ftBCD, ftCurrency:
      CellDouble(vcol, vrow, field.AsFloat, []);
    else
//      Cellstr(vcol, vrow, field.asstring, []);
      Cellstr(vcol, vrow, get_Field_Value(Field), []);
  end;
end;

end.

